package poly;

/**
 * Bone class
 * 
 * @author Shun Moriya <shun126@users.sourceforge.jp>
 */
public class Bone
{
	Bone parentBone;
	Model model;
	public float rotation[];
	public float translation[];
	public float matrix[];
	
	public Bone()
	{
		this.parentBone = null;
		this.model = null;
		rotation = new float[4];
		translation = new float[4];
		matrix = new float[4*4];
		poly.Graphic.unitVector(rotation);
		translation[0] = 0.0f;
		translation[1] = 0.0f;
		translation[2] = 0.0f;
		translation[3] = 1.0f;
		poly.Graphic.unitMatrix(matrix);
	}
	public Bone(Model model)
	{
		this.parentBone = null;
		this.model = model;
		rotation = new float[4];
		translation = new float[4];
		matrix = new float[4*4];
		poly.Graphic.unitVector(rotation);
		translation[0] = 0.0f;
		translation[1] = 0.0f;
		translation[2] = 0.0f;
		translation[3] = 1.0f;
		poly.Graphic.unitMatrix(matrix);
	}
	public Bone(Model model, Bone parentBone, float length)
	{
		this.parentBone = parentBone;
		this.model = model;
		rotation = new float[4];
		translation = new float[4];
		matrix = new float[4 * 4];
		poly.Graphic.unitVector(rotation);
		translation[0] = 0.0f;
		translation[1] = 0.0f;
		translation[2] = -length;
		translation[3] = 1.0f;
		poly.Graphic.unitMatrix(matrix);
	}
	public Bone getParentBone()
	{
		return parentBone;
	}
	public Model getBodel()
	{
		return model;
	}
	public float[] getRotation()
	{
		return rotation;
	}
	public float[] getTranslation()
	{
		return translation;
	}
	public float[] getMatrix()
	{
		return matrix;
	}
}
