/*
 *  xNgƍsvZ̊֐Q
 *
 *  xNg̔z`͈ȉ̂悤ɂȂĂ܂.
 *   v =|v[0] v[1] v[2] v[3]|
 *
 *
 *  s̔z`͈ȉ̂悤ɂȂĂ܂.
 *      |v[4*0+0] v[4*0+1] v[4*0+2] v[4*0+3]|
 *   m =|v[4*1+0] v[4*1+1] v[4*1+2] v[4*1+3]|
 *      |v[4*2+0] v[4*2+1] v[4*2+2] v[4*2+3]|
 *      |v[4*3+0] v[4*3+1] v[4*3+2] v[4*3+3]|
 */

package poly;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class Graphic
{
	static final public int TRANSFORM_WORLD = 0;
	static final public int TRANSFORM_VIEW  = 1;
	static final public int TRANSFORM_PROJ  = 2;

	/** view vector */
	static final public float vView[] = new float[4];
	/** light vector */
	static final public float vLight[] = new float[4];
	/** view position */
	static final public float vViewPosition[] = new float[4];
	/** light position vector */
	static final public float vLightPosition[] = new float[4];
	/** light color vector */
	static final public float vLightColor[] = new float[4];
	/** ambient color vector */
	static final public float vAmbientColor[] = new float[4];
	/** speculaer color vector */
	static final public float vSpeculerColor[] = new float[4];
	/** [hϊs */
	static final public float mWorld[]  = new float[4 * 4];
	/** r[ϊs */
	static final public float mView[] = new float[4 * 4];
	/** }X^[s */
	static final public float mMaster[] = new float[4 * 4];
	/** ˉeϊs */
	static final public float mProj[] = new float[4 * 4];

	static public boolean speculerSupport;
	static public boolean lightSupport;
	static public boolean textureSupport;
	static public boolean toonShading;
	
	/** view port */
	static private int viewPortLeft;
	static private int viewPortRight;
	static private int viewPortTop;
	static private int viewPortBottom;
	static private int viewPortWidth;
	static private int viewPortHeight;
	static private int viewPortCenterX;
	static private int viewPortCenterY;

	static private int pbuf[];		// 32bitsNZobt@
	static private int zbuf[];		// 32bityobt@

	static private int BUFFERW;		// obt@
	static private int BUFFERH;		// obt@
	static private int CENTERX;
	static private int CENTERY;

	static private int min [];
	static private int max [];
	static private int minz[];
	static private int maxz[];
	static private int minr[];
	static private int maxr[];
	static private int ming[];
	static private int maxg[];
	static private int minb[];
	static private int maxb[];
	static private int minu[];
	static private int maxu[];
	static private int minv[];
	static private int maxv[];
	static private int minsr[];
	static private int maxsr[];
	static private int minsg[];
	static private int maxsg[];
	static private int minsb[];
	static private int maxsb[];

	static private TextureEnvironment textureEnvironment[];	// 32biteNX`obt@
    
	static int renderTexture;
	static float renderMatrix[]; 
	static Point renderPoint[];
    
    
	/** 
	 * 
	 * @param   w   ʂ̕
	 * @param   h   ʂ̍
	 * @param	speculerSupport	XyLLɂ
	 * @param	lightSupport	vZLɂ
	 */
	static final public void init(int w, int h, boolean light, boolean texture, boolean speculer)
	{
		toonShading = false;
		
		BUFFERW = w;
		BUFFERH = h;
		CENTERX = w / 2;
		CENTERY = h / 2;

		pbuf = new int[BUFFERW * BUFFERH];
		zbuf = new int[BUFFERW * BUFFERH];
		min  = new int[BUFFERH];
		max  = new int[BUFFERH];
		minz = new int[BUFFERH];
		maxz = new int[BUFFERH];
		lightSupport = light;
		if(lightSupport)
		{
			minr = new int[BUFFERH];
			maxr = new int[BUFFERH];
			ming = new int[BUFFERH];
			maxg = new int[BUFFERH];
			minb = new int[BUFFERH];
			maxb = new int[BUFFERH];
		}
		textureSupport = texture;
		if(textureSupport == true)
		{
			minu = new int[BUFFERH];
			maxu = new int[BUFFERH];
			minv = new int[BUFFERH];
			maxv = new int[BUFFERH];
		}
		speculerSupport = speculer;
		if(speculerSupport == true)
		{
			minsr= new int[BUFFERH];
			maxsr= new int[BUFFERH];
			minsg= new int[BUFFERH];
			maxsg= new int[BUFFERH];
			minsb= new int[BUFFERH];
			maxsb= new int[BUFFERH];
		}
		textureEnvironment = new TextureEnvironment[50];
	
		renderTexture = -1;
		renderPoint = new Point[4];
		for(int i = 0; i < 4; i++)
		{
			renderPoint[i] = new Point();
		}
	
		setViewPort(0, 0, w, h);
		projection(40.0f, 8192.0f, (float)java.lang.Math.PI / 8, w / h);
	}
	/**
	 * eNX`̐ݒ
	 * @param   texture eNX`
	 * @exception   InterruptedException
	 */
	static final public void setTexture(int page, Image texture) throws InterruptedException
	{
		textureEnvironment[page] = new TextureEnvironment(texture);
	}
	/**
	 * Clear depth buffer
	 */
	static final public void clear()
	{
		for(int y = viewPortTop; y < viewPortBottom; y++)
		{
			int offset = y * BUFFERW;
			for(int x = viewPortLeft; x < viewPortRight; x++)
			{
				pbuf[offset + x] = 0xff808080;
				zbuf[offset + x] = 2147483647;
			}
		}
	}
	/**
	 * _OJn
	 */
	static final public void beginScene()
	{
	}
	/**
	 * _OJn
	 */
	static final public void beginRender()
	{
		unitMatrix(mMaster);
		mulMatrix(mMaster, mMaster, mWorld);
		
		//[h]us̍쐬
		float im[] = new float[4 * 4];
		transposeMatrix(im, mMaster);
		
		// š
		applyMatrix(vLight, im, vLightPosition);
		normalizeVector(vLight, vLight);
		
		//[hEr[]us̍쐬
		mulMatrix(mMaster, mMaster, mView);
		transposeMatrix(im, mMaster);

		// xNg
		poly.Graphic.applyMatrix(vView, im, vViewPosition);
		poly.Graphic.normalizeVector(vView, vView);

		//}X^[s̍쐬
		mulMatrix(mMaster, mMaster, mProj);
	}
	/**
	 * _OI
	 * 
	 * @param   applet  Avbgւ̎Q
	 * @param   offscreen   ItXN[ւ̎Q
	 */
	static final public void endScene(Applet applet, Graphics offscreen)
	{
		offscreen.drawImage(
			applet.createImage(new MemoryImageSource(BUFFERW, BUFFERH, pbuf, 0, BUFFERW)),
			0,
			0,
			null
		);
	}
	/**
	 * _ʒuݒ
	 * @param	x		XW
	 * @param	y		YW
	 * @param	z		ZW
	 */
	static final public void setViewPosition(float x, float y, float z)
	{
		vViewPosition[0] = x;
		vViewPosition[1] = y;
		vViewPosition[2] = z;
		vViewPosition[3] = 1.0f;
	}
	/**
	 * ʒuݒ
	 * @param	x		XW
	 * @param	y		YW
	 * @param	z		ZW
	 */
	static final public void setLightPosition(float x, float y, float z)
	{
		vLightPosition[0] = x;
		vLightPosition[1] = y;
		vLightPosition[2] = z;
		vLightPosition[3] = 1.0f;
	}
	/**
	 * Fݒ
	 * @param	r		ԐF
	 * @param	g		ΐF
	 * @param	b		F
	 */
	static final public void setLightColor(float r, float g, float b)
	{
		vLightColor[0] = r;
		vLightColor[1] = g;
		vLightColor[2] = b;
		vLightColor[3] = 1.0f;
	}
	/**
	 * Fݒ
	 * @param	r		ԐF
	 * @param	g		ΐF
	 * @param	b		F
	 */
	static final public void setAmbientColor(float r, float g, float b)
	{
		vAmbientColor[0] = r;
		vAmbientColor[1] = g;
		vAmbientColor[2] = b;
		vAmbientColor[3] = 1.0f;
	}
	/**
	 * XyLFݒ
	 * @param	r		ԐF
	 * @param	g		ΐF
	 * @param	b		F
	 */
	static final public void setSpeculerColor(float r, float g, float b)
	{
		vSpeculerColor[0] = r;
		vSpeculerColor[1] = g;
		vSpeculerColor[2] = b;
		vSpeculerColor[3] = 1.0f;
	}
	///////////////////////////////////////////////
	
	static final public void begin()
	{
	}
	static final public void swap()
	{
		Point point = renderPoint[0]; 
		renderPoint[0] = renderPoint[1];
		renderPoint[1] = renderPoint[2];
		renderPoint[2] = point;
	}
	static final public void setMatrix(float matrix[])
	{
		renderMatrix = matrix;
	}
	static final public void setTexCoord(int index, float u, float v)
	{
		TextureEnvironment env = textureEnvironment[renderTexture];
		if(env != null)	// kari desu!
		{
			renderPoint[index].u = (int)(env.width * u) * (1 << 16);
			renderPoint[index].v = (int)(env.height * v) * (1 << 16);
		}
	}
	static final public void setColor(int index, float color[])
	{
		renderPoint[index].r = (int)(color[0] * (1 << 16));
		renderPoint[index].g = (int)(color[1] * (1 << 16));
		renderPoint[index].b = (int)(color[2] * (1 << 16));
	}
	static final public void setNormal(int index, float normal[])
	{
		renderPoint[index].x = (int)(normal[0] * (1 << 16));
		renderPoint[index].y = (int)(normal[1] * (1 << 16));
		renderPoint[index].z = (int)(normal[2] * (1 << 16));
	}
	static final public float tempo[] = new float[4];
	static final public void setVertex(int index, float vertex[])
	{
		poly.Graphic.rotTransPers(tempo, renderMatrix, vertex);
		renderPoint[index].x = (int)(tempo[0] * (1 << 16));
		renderPoint[index].y = (int)(tempo[1] * (1 << 16));
		renderPoint[index].z = (int)(tempo[2] * (1 << 16));
	}
	static final public void setTexture(int texture)
	{
		renderTexture = texture;
	}
	static final public void end()
	{
/*		if(eye.DotProduct(vtx[i].n) >= 0)
		{
		}
*/
//		int speculer[] = poly.Graphic.speculerColorVector(vertex, normal);
		drawTriangle(renderPoint[0], renderPoint[1], renderPoint[2], renderTexture);
	}
	/**
	 * |S`
	 * @param   v1  _
	 * @param   v2  _
	 * @param   v3  _
	 */
	static final private void drawTriangle(Point v1, Point v2, Point v3, int tno)
	{
		//obt@̎gp͈͂ݒî߁j
		int top = +2147483647;
		int btm = -2147483648;
		if(top > v1.y)
			top = v1.y;
		if(top > v2.y)
			top = v2.y;
		if(top > v3.y)
			top = v3.y;
		if(btm < v1.y)
			btm = v1.y;
		if(btm < v2.y)
			btm = v2.y;
		if(btm < v3.y)
			btm = v3.y;
		top >>= 16;
		btm >>= 16;
		if(top < 0)		top = 0;
		if(btm > BUFFERH)	btm = BUFFERH;

		//őŏobt@̏
		for(int i = top; i < btm; i ++)
		{
			min[i] = +2147483647;
			max[i] = -2147483648;
		}

		//XLGbW
		scanEdge(v1, v2);
		scanEdge(v2, v3);
		scanEdge(v3, v1);

		//őŏobt@ɊÂĕ`悷B
		for(int y = top; y < btm; y ++)
		{
			//obt@XVȂXLbv
			if(min[y] == +2147483647)
				continue;

			final int offset = y * BUFFERW;

			//lvZ
			int l = (max[y] - min[y]) + 1;
			int addz = (maxz[y] - minz[y]) / l;
			int addr = (maxr[y] - minr[y]) / l;
			int addg = (maxg[y] - ming[y]) / l;
			int addb = (maxb[y] - minb[y]) / l;
			int addu = (maxu[y] - minu[y]) / l;
			int addv = (maxv[y] - minv[y]) / l;
			int addsr= (maxsr[y]-minsr[y]) / l;
			int addsg= (maxsg[y]-minsg[y]) / l;
			int addsb= (maxsb[y]-minsb[y]) / l;

			//lݒ
			int z = minz[y];
			int r = minr[y];
			int g = ming[y];
			int b = minb[y];
			int u = minu[y];
			int v = minv[y];
			int sr= minsr[y];
			int sg= minsg[y];
			int sb= minsb[y];

			for(int x = min[y]; x <= max[y]; x++, z += addz, r += addr, g += addg, b += addb, u += addu, v += addv, sr += addsr, sg += addsg, sb += addsb)
			{
				if (x < 0 || x >= BUFFERW)
					continue;
				int p = offset + x;
				if(zbuf[p] > z)
				{
					int texel = 0xFFFFFF;
					if(tno >= 0 && textureEnvironment[tno] != null)
					{
						texel = (((v >> 16) & textureEnvironment[tno].maskHeight) << textureEnvironment[tno].shiftCount);
						texel += ((u >> 16) & textureEnvironment[tno].maskWidth);
						texel = textureEnvironment[tno].pixel[texel];
					}
					if((texel & 0xffffff) != 0)
					{
						int tr, tg, tb;
						
						if(toonShading)
						{
							tr = (( (r > (128<<16) ? 255 : 64) * ((texel & 0xff0000)>>16) )>>8) + (sr > (128<<16) ? 255 : 64);
							tg = (( (g > (128<<16) ? 255 : 64) * ((texel & 0x00ff00)>>8 ) )>>8) + (sg > (128<<16) ? 255 : 64);
							tb = (( (b > (128<<16) ? 255 : 64) * ((texel & 0x0000ff)    ) )>>8) + (sb > (128<<16) ? 255 : 64);
						}else{
							tr = (( (r>>16) * ((texel & 0xff0000)>>16) )>>8) + (sr>>16);
							tg = (( (g>>16) * ((texel & 0x00ff00)>>8 ) )>>8) + (sg>>16);
							tb = (( (b>>16) * ((texel & 0x0000ff)    ) )>>8) + (sb>>16);
						}
						if(tr > 255)	tr = 255;
						if(tg > 255)	tg = 255;
						if(tb > 255)	tb = 255;
						pbuf[p] = (tr << 16) | (tg << 8) | tb | 0xff000000;
						zbuf[p] = z;
					}
				}
			}
		}
	}
	/**
	 * scan line
	 * @param   v1  	start point
	 * @param   v2  	end point
	 */
	static final private void scanEdge(Point v1, Point v2)
	{
		int l = java.lang.Math.abs((int)((v2.y >> 16) - (v1.y >> 16))) + 1;

		//lvZ
		int addx = (v2.x - v1.x) / l;
		int addy = (v2.y - v1.y) / l;
		int addz = (v2.z - v1.z) / l;
		int addr = (v2.r - v1.r) / l;
		int addg = (v2.g - v1.g) / l;
		int addb = (v2.b - v1.b) / l;
		int addu = (v2.u - v1.u) / l;
		int addv = (v2.v - v1.v) / l;
		int addsr = (v2.sr - v1.sr) / l;
		int addsg = (v2.sg - v1.sg) / l;
		int addsb = (v2.sb - v1.sb) / l;

		//lݒ
		int x = v1.x;
		int y = v1.y;
		int z = v1.z;
		int r = v1.r;
		int g = v1.g;
		int b = v1.b;
		int u = v1.u;
		int v = v1.v;
		int sr= v1.sr;
		int sg= v1.sg;
		int sb= v1.sb;

		//XL
		for(int i=0;i<l;i++,x+=addx,y+=addy,z+=addz,r+=addr,g+=addg,b+=addb,u+=addu,v+=addv,sr+=addsr,sg+=addsg,sb+=addsb){			
			int py = y >> 16;
			int px = x >> 16;

			if(py < 0 || py >= BUFFERH)
				continue;

			if(min[py] > px)
			{
				min [py] = px;
				minz[py] = z;
				minr[py] = r;
				ming[py] = g;
				minb[py] = b;
				minu[py] = u;
				minv[py] = v;
				minsr[py] = sr;
				minsg[py] = sg;
				minsb[py] = sb;
			}

			if(max[py] < px)
			{
				max [py] = px;
				maxz[py] = z;
				maxr[py] = r;
				maxg[py] = g;
				maxb[py] = b;
				maxu[py] = u;
				maxv[py] = v;
				maxsr[py] = sr;
				maxsg[py] = sg;
				maxsb[py] = sb;
			}
		}
	}


	/////////////////////////////////////////////////////////////////////
	// Z֌W̃[`
	/////////////////////////////////////////////////////////////////////
	/**
	 * ϊsݒ
	 * @param	type	s̎
	 * @param	m		ϊs
	 */
	static public void setTransform(int type, float m[])
	{
		switch(type)
		{
		case TRANSFORM_WORLD:
			copyMatrix(mWorld, m);
			break;
		case TRANSFORM_VIEW:
			copyMatrix(mView, m);
			break;
		case TRANSFORM_PROJ:
			copyMatrix(mProj, m);
			break;
		}
	}
	/**
	 * r[|[g̐ݒ
	 * @param	x	W
	 * @param	y	W
	 * @param	w	
	 * @param	h	
	 */
	static public void setViewPort(int x, int y, int w, int h)
	{
		viewPortWidth   = w / 2;
		viewPortHeight  = h / 2;
		viewPortLeft    = x;
		viewPortRight   = x + w;
		viewPortTop     = y;
		viewPortBottom  = y + h;
		viewPortCenterX = x + w / 2;
		viewPortCenterY = y + h / 2;
	}
	/**
	 * ˉeϊs
	 * @param	near	jANbv
	 * @param	far		t@[Nbv
	 * @param	fov		piWAj
	 * @param	aspect	AXyNg
	 */
	static public void projection(float near, float far, float fov, float aspect)
	{
		float w = aspect * (float)(java.lang.Math.cos(fov) / java.lang.Math.sin(fov));
		float h = 1.0f   * (float)(java.lang.Math.cos(fov) / java.lang.Math.sin(fov));
		float q = far / (far - near);
		unitMatrix(mProj);
		mProj[0 * 4 + 0] = w;
		mProj[1 * 4 + 1] = h;
		mProj[2 * 4 + 2] = q;
		mProj[2 * 4 + 3] = 1.0f;
		mProj[3 * 4 + 2] = -q * near;
	}
	/**
	 * r[ϊs̍쐬
	 * @param	mat		r[ϊs(matrix)
	 * @param	from	J̈ʒu(vector)
	 * @param	at		^[Qbg̈ʒu(vector)
	 * @param	wup		J̏(vector)
	 */
	static final public float[] lookat(float from[], float at[], float wup[])
	{
		copyVector(vView, from);
		
		float m[] = new float[4 * 4];
		float x[] = new float[4];
		float y[] = new float[4];
		float z[] = new float[4];
		z[0] = at[0] - from[0];
		z[1] = at[1] - from[1];
		z[2] = at[2] - from[2];
		normalizeVector(z, z);
		outerProduct(x, wup, z);
		normalizeVector(x, x);
		outerProduct(y, x, z);
		m[4 * 0 + 0] = x[0];
		m[4 * 0 + 1] = x[1];
		m[4 * 0 + 2] = x[2];
		m[4 * 0 + 3] = 0;
		m[4 * 1 + 0] = y[0];
		m[4 * 1 + 1] = y[1];
		m[4 * 1 + 2] = y[2];
		m[4 * 1 + 3] = 0;
		m[4 * 2 + 0] = z[0];
		m[4 * 2 + 1] = z[1];
		m[4 * 2 + 2] = z[2];
		m[4 * 2 + 3] = 0;
		m[4 * 3 + 0] = at[0];
		m[4 * 3 + 1] = at[1];
		m[4 * 3 + 2] = at[2];
		m[4 * 3 + 3] = 1.0f;
		return(m);
/*
		float view[] = new float[4];
		view[0] = at[0] - from[0];
		view[1] = at[1] - from[1];
		view[2] = at[2] - from[2];
		normalizeVector(view, view);
		
		float dot = this.innerProduct(wup, view);
		
		float up[] = new float[4];
		
		up[0] = wup[0] - dot * view[0];
		up[1] = wup[1] - dot * view[1];
		up[2] = wup[2] - dot * view[2];
		
		normalizeVector(up, up);
		
		Vector right = new Vector();
		right.CrossProduct(up,view);
		
		m00 = right.x;	m01 = up.x;	m02 = view.x;	m03 = 0;
		m10 = right.y;	m11 = up.y;	m12 = view.y;	m13 = 0;
		m20 = right.z;	m21 = up.z;	m22 = view.z;	m23 = 0;
		m30 = -from.DotProduct(right);
		m31 = -from.DotProduct(up   );
		m32 = -from.DotProduct(view );
		m33 =  1.0f;
*/
	}
	/**
	 * [hWnɑ΂JWn`
	 * 	@param	p		camera position (in the world)
	 * 	@param	zd		eye direction
	 * 	@param	yd		vertical direction
	 * 	@param	xd		zd x yd: wing direction
	 * 	@param	yd		yd x xd:  real veritical direction
	 *
	 * 	        | xd0 yd0 zd0 p0 |
	 * 	M = inv | xd1 yd1 zd1 p1 |
	 * 	        | xd2 yd2 zd2 p2 |
	 * 	        |   0   0   0  1 |
	 */
	static final public void lookat2(float m[], float p[], float zd[], float yd[])
	{
		float m0[] = new float[4*4];
		float xd[] = new float[4];
		float v0[] = new float[4];
		float v1[] = new float[4];

		unitVector(xd);
		unitVector(v0);
		unitVector(v1);
		unitMatrix(m0);
		outerProduct(xd, yd, zd);
		normalizeVector(m0, xd);
		normalizeVector(v1, zd);
		outerProduct(v0, v1, m0);
		m0[4*1+0] = v0[0];
		m0[4*1+1] = v0[1];
		m0[4*1+2] = v0[2];
		m0[4*1+3] = v0[3];
		m0[4*2+0] = v1[0];
		m0[4*2+1] = v1[1];
		m0[4*2+2] = v1[2];
		m0[4*2+3] = v1[3];
		transposeMatrix(m0, m0);
		transMatrix(m0, m0, p);
		inversMatrix(m, m0);
	}
	/**
	 * [hWnɑ΂JWn`(]L)
	 * @param	p		original camera position (in the world)
	 * @param	zd		original eye direction
	 * @param	yd		original vertical direction
	 * @param	rot		rotation vector
	 */
	static final public void lookat3(float m[], float p[], float zd[], float yd[], float rot[])
	{
		float work[] = new float[4*4];
		float direction[] = new float[4];
		float vertical[] = new float[4];
		float position[] = new float[4];

		unitVector(direction);
		unitVector(vertical);
		unitVector(position);
		unitMatrix(work);
		rotMatrixX(work,work,rot[0]);
		rotMatrixY(work,work,rot[1]);
		rotMatrixZ(work,work,rot[2]);
		applyMatrix(direction, work, zd);
		applyMatrix(vertical, work, yd);
		applyMatrix(position, work, p);
//		cameraMatrix(m, position, direction, vertical);
	}
	/**
	 * xNg̕
	 * @param	v0	vector(output)
	 * @param	v1	vector(input)
	 */
	static final public void copyVector(float v0[], float v1[])
	{
		v0[0] = v1[0];
		v0[1] = v1[1];
		v0[2] = v1[2];
		v0[3] = v1[3];
	}
	/**
	 * xNg̕ (}gbNX1iڂɕ)
	 * @param	m	matrix(output)
	 * @param	v	vector(input)
	 */
	static final public void copyVectorToMatrix1(float m[], float v[])
	{
		m[4*1+0] = v[0];
		m[4*1+1] = v[1];
		m[4*1+2] = v[2];
		m[4*1+3] = v[3];
	}
	/**
	 * xNg̕ (}gbNX2iڂɕ)
	 * @param	m	matrix(output)
	 * @param	v	vector(input)
	 */
	static final public void copyVectorToMatrix2(float m[], float v[])
	{
		m[4*2+0] = v[0];
		m[4*2+1] = v[1];
		m[4*2+2] = v[2];
		m[4*2+3] = v[3];
	}
	/**
	 * xNg̕ (}gbNX3iڂɕ)
	 * @param	m	matrix(output)
	 * @param	v	vector(input)
	 */
	static final public void copyVectorToMatrix3(float m[], float v[])
	{
		m[4*3+0] = v[0];
		m[4*3+1] = v[1];
		m[4*3+2] = v[2];
		m[4*3+3] = v[3];
	}
	/**
	 * 4Z (ADD/xyzw)
	 * @param	v0	vector(output)
	 * @param	v1	vector(input)
	 * @param	v2	vector(input)
	 */
	static final public void addVector(float v0[], float v1[], float v2[])
	{
		v0[0] = v1[0] + v2[0];
		v0[1] = v1[1] + v2[1];
		v0[2] = v1[2] + v2[2];
		v0[3] = v1[3] + v2[3];
	}
	/**
	 * 4񌸎Z (SUB/xyzw)
	 * @param	v0	vector(output)
	 * @param	v1	vector(input)
	 * @param	v2	vector(input)
	 */
	static final public void subVector(float v0[], float v1[], float v2[])
	{
		v0[0] = v1[0] - v2[0];
		v0[1] = v1[1] - v2[1];
		v0[2] = v1[2] - v2[2];
		v0[3] = v1[3] - v2[3];
	}
	/**
	 * 4ώZiMUL/xyzw: ςł͂ȂƂɒӁj
	 * @param	v0	vector(output)
	 * @param	v1	vector(input)
	 * @param	v2	vector(input)
	 */
	static final public void mulVector(float v0[], float v1[], float v2[])
	{
		v0[0] = v1[0] * v2[0];
		v0[1] = v1[1] * v2[1];
		v0[2] = v1[2] * v2[2];
		v0[3] = v1[3] * v2[3];
	}
	/**
	 * XJ[lZ (MULx/xyzw)
	 * @param	v0	vector(output)
	 * @param	v1	vector(input)
	 * @param	t	value(input)
	 */
	static final public void scaleVector(float v0[], float v1[], float t)
	{
		v0[0] = v1[0] * t;
		v0[1] = v1[1] * t;
		v0[2] = v1[2] * t;
		v0[3] = v1[3] * t;
	}
	/**
	 * Q̃xNg̓ς߂
	 * @param	v0	vector(output)
	 * @param	v1	vector(input)
	 */
	static final public float innerProduct(float v0[], float v1[])
	{
		return(v0[0]*v1[0] + v0[1]*v1[1] + v0[2]*v1[2]);
	}
	/**
	 * Q̃xNg̊Oς߂
	 * @param	v0	vector(output)
	 * @param	v1	vector(input)
	 * @param	v2	vector(input)
	 */
	static final public void outerProduct(float v0[], float v1[], float v2[])
	{
		v0[0] = v1[1]*v2[2] - v1[2]*v2[1];
		v0[1] = v1[2]*v2[0] - v1[0]*v2[2];
		v0[2] = v1[0]*v2[1] - v1[1]*v2[0];
		v0[3] = 1.0f;
	}
	/**
	 * xNg̐Ks
	 * @param	v0	vector(output)
	 * @param	v1	vector(input)
	 */
	static final public void normalizeVector(float v0[], float v1[])
	{
		//PʃxNgƂ͒P̃xNĝƁB
		float _l = (float)(1.0f / java.lang.Math.sqrt(v1[0]*v1[0] + v1[1]*v1[1] + v1[2]*v1[2]));
		v0[0] *= _l;
		v0[1] *= _l;
		v0[2] *= _l;
		v0[3] = 1.0f;
/*
		float norm, dnorm;

		norm = (float)java.lang.Math.sqrt(v1[0]*v1[0] + v1[1]*v1[1] + v1[2]*v1[2]);
		if(norm > 0)
		{
			dnorm = 1.0f / norm;
			v0[0] = v1[0] * dnorm;
			v0[1] = v1[1] * dnorm;
			v0[2] = v1[2] * dnorm;
			v0[3] = v1[3];
		}
*/
	}
	/**
	 * s̕
	 * @param	v0	matirx(output)
	 * @param	v1	matirx(input)
	 */
	static final public void copyMatrix(float m0[], float m1[])
	{
		for(int i = 0; i < 4*4; i ++)
			m0[i] = m1[i];
	}
	/**
	 * xNgɃ}gbNXZB
	 * }gbNXmɃxNgv0EZāAv1ɗ^
	 * v0=m0*v1
	 * @param	v0	vector(output)
	 * @param	m0	matrix(input)
	 * @param	v1	vector(input)
	 */
	static final public void applyMatrix(float v0[], float m0[], float v1[])
	{
		float v[] = new float[4];
//		unitVector(v);
		v[0] = m0[4*0+0]*v1[0] + m0[4*1+0]*v1[1] + m0[4*2+0]*v1[2] + m0[4*3+0]*v1[3];
		v[1] = m0[4*0+1]*v1[0] + m0[4*1+1]*v1[1] + m0[4*2+1]*v1[2] + m0[4*3+1]*v1[3];
		v[2] = m0[4*0+2]*v1[0] + m0[4*1+2]*v1[1] + m0[4*2+2]*v1[2] + m0[4*3+2]*v1[3];
		v[3] = m0[4*0+3]*v1[0] + m0[4*1+3]*v1[1] + m0[4*2+3]*v1[2] + m0[4*3+3]*v1[3];
		copyVector(v0, v);
	}
	/**
	 * Q}gbNX̐ς߂
	 * }gbNXm1Ƀ}gbNXm2EZāAm0ɗ^
	 * m0=m1*m2
	 * @param	m0	matrix(output)
	 * @param	m1	matrix(input)
	 * @param	m2	matrix(input)
	 */
	static final public void mulMatrix(float m0[], float m1[], float m2[])
	{
		float m[] = new float[4*4];
		for(int i=0; i<4; i++)
		{
			for(int j=0; j<4; j++)
			{
				m[4*i+j] = m1[4*i+0] * m2[4*0+j]
						 + m1[4*i+1] * m2[4*1+j]
						 + m1[4*i+2] * m2[4*2+j]
						 + m1[4*i+3] * m2[4*3+j];
			}
		}
		copyMatrix(m0, m);
	}
	/**
	 * s̕sړ
	 * ^ꂽxNgA}gbNX𕽍sړ
	 * @param	tv		:ړxNg
	 * @param	m1		:}gbNX
	 * @param	m0		o:}gbNX
	 */
	static final public void transMatrix(float m0[], float m1[], float tv[])
	{
		for(int i=0; i<4; i++)
		{
			for(int j=0; j<4; j++)
			{
				m0[4*i+j] = m1[4*i+j];
			}
		}
		m0[4*0+3] = m1[4*0+3] + tv[0];
		m0[4*1+3] = m1[4*1+3] + tv[1];
		m0[4*2+3] = m1[4*2+3] + tv[2];
		m0[4*3+3] = m1[4*3+3] + tv[3];
	}
	/**
	 * }gbNXɕsړvf
	 * @param	m		:}gbNX
	 * @param	t		:ړxNg
	 */
	static final public void setTransMatrix(float m[], float v[])
	{
		float tm[] = new float[4*4];
		unitMatrix(tm);
		tm[4*3+0] = v[0];
		tm[4*3+1] = v[1];
		tm[4*3+2] = v[2];
		tm[4*3+3] = v[3];
		mulMatrix(m, m, tm);
	}
	/**
	 * Pʍs
	 * @param	m0		o:}gbNX
	 */
	static final public void unitMatrix(float m0[])
	{
		for(int i=0; i<4; i++)
		{
			for(int j=0; j<4; j++)
			{
				m0[4*i+j] = (i==j)? 1.0f : 0.0f;
			}
		}
	}
	/**
	 * PʃxNg
	 * @param	v		óFxNg
	 */
	static final public void unitVector(float v[])
	{
		v[0] = v[1] = v[2] = 0.0f;
		v[3] = 1.0f;
	}
	/**
	 * xNgݒ
	 * @param	v		óFxNg
	 * @param	x		XW
	 * @param	y		YW
	 * @param	z		ZW
	 */
	static final public void setVector(float v[], float x, float y, float z)
	{
		v[0] = x;
		v[1] = y;
		v[2] = z;
		v[3] = 1.0f;
	}
	/**
	 * y𒆐SƂs̉]
	 * @param	m0		o:}gbNX
	 * @param	m1		:}gbNX
	 * @param	rz		:]p(L͈:- ` )
	 */
	static final public void rotMatrixX(float m0[], float m1[], float rx)
	{
		float rot[] = new float[4*4];
		unitMatrix(rot);
		
		//  rx = rx * (3.141592/180.0);
		rot[4*1+1] = (float)java.lang.Math.cos(rx);
		rot[4*1+2] = (float)java.lang.Math.sin(rx);
		
		rot[4*2+1] = - (float)java.lang.Math.sin(rx);
		rot[4*2+2] = (float)java.lang.Math.cos(rx);
		
		mulMatrix(m0, rot, m1);
	}
	/**
	 * x𒆐SƂs̉]
	 * @param	m0		o:}gbNX
	 * @param	m1		:}gbNX
	 * @param	ry		:]p(L͈:- ` )
	 */
	static final public void rotMatrixY(float m0[], float m1[], float ry)
	{
		float rot[] = new float[4*4];
		unitMatrix(rot);
		
		//  ry = ry * (3.141592/180.0);
		rot[4*0+0] = (float)java.lang.Math.cos(ry);
		rot[4*0+2] = - (float)java.lang.Math.sin(ry);
		
		rot[4*2+0] = (float)java.lang.Math.sin(ry);
		rot[4*2+2] = (float)java.lang.Math.cos(ry);
		
		mulMatrix(m0, rot, m1);
	}
	/**
	 * y𒆐SƂs̉]
	 * @param	m0		o:}gbNX
	 * @param	m1		:}gbNX
	 * @param	rz		:]p(L͈:- ` )
	 */
	static final public void rotMatrixZ(float m0[], float m1[], float rz)
	{
		float rot[] = new float[4*4];
		unitMatrix(rot);

		//  rz = rz * (3.141592/180.0);
		rot[4*0+0] = (float)java.lang.Math.cos(rz);
		rot[4*0+1] = (float)java.lang.Math.sin(rz);
		
		rot[4*1+0] = - (float)java.lang.Math.sin(rz);
		rot[4*1+1] = (float)java.lang.Math.cos(rz);
		
		mulMatrix(m0, rot, m1);
	}
	/**
	 * X,Y,Z𒆐SƂs̉]BZXY̏Ԃŉ]
	 * @param	m0		o̓}gbNX
	 * @param	m1		̓}gbNX
	 * @param	rot		͉]xNg(L͈:- ` )
	 */
	static final public void rotMatrixZXY(float m0[], float m1[], float rot[])
	{
		rotMatrixZ(m0, m1, rot[2]);
		rotMatrixX(m0, m0, rot[0]);
		rotMatrixY(m0, m0, rot[1]);
	}
	/**
	 * X,Y,Z𒆐SƂs̉]BYXZ̏Ԃŉ]
	 * @param	m0		o̓}gbNX
	 * @param	m1		̓}gbNX
	 * @param	rot		͉]xNg(L͈:- ` )
	 */
	static final public void rotMatrixYXZ(float m0[], float m1[], float rot[])
	{
		rotMatrixY(m0, m1, rot[1]);
		rotMatrixX(m0, m0, rot[0]);
		rotMatrixZ(m0, m0, rot[2]);
	}
	/**
	 * xNgv1̊evf min maxƂăNvv0ɗ^D
	 * @param	v0		o:xNg
	 * @param	v1		:xNg
	 * @param	min		:(؎̂ĉ)
	 * @param	max		:(؎̂ď)
	 */
	static final public void clampVector(float v0[], float v1[], float min, float max)
	{
		float vect[] = new float[4];
		unitVector(vect);
		
		v0[0] = v1[0]<min ? min : (v1[0]>max ? max : v1[0]);
		v0[1] = v1[1]<min ? min : (v1[1]>max ? max : v1[1]);
		v0[2] = v1[2]<min ? min : (v1[2]>max ? max : v1[2]);
		v0[3] = v1[3]<min ? min : (v1[3]>max ? max : v1[3]);

		vect[0] = v1[0]<min ? min : (v1[0]>max ? max : v1[0]);
		vect[1] = v1[1]<min ? min : (v1[1]>max ? max : v1[1]);
		vect[2] = v1[2]<min ? min : (v1[2]>max ? max : v1[2]);
		vect[3] = v1[3]<min ? min : (v1[3]>max ? max : v1[3]);
		copyVector(v0, vect);
	}
	/**
	 * XyLFvZ܂
	 */
	static final public int[] speculerColorVector(float vertex[], float normal[])
	{
		//_@ƌƂ̂Ȃp
		float w = poly.Graphic.innerProduct(vLight, normal);
		
		//_F߂
		int r = (int)((vAmbientColor[0] + w * vLightColor[0]) * 255 * 0xffff);
		int g = (int)((vAmbientColor[1] + w * vLightColor[1]) * 255 * 0xffff);
		int b = (int)((vAmbientColor[2] + w * vLightColor[2]) * 255 * 0xffff);
		if (r < 0)
			r = 0;
		if (g < 0)
			g = 0;
		if (b < 0)
			b = 0;
			
		//XyL[߂
		float n[] = new float[4];
		n[0] = normal[0] * 2 * w - vLight[0];
		n[1] = normal[1] * 2 * w - vLight[1];
		n[2] = normal[2] * 2 * w - vLight[2];
		n[3] = 1.0f;
		poly.Graphic.normalizeVector(n, n);
						
		// xNgƔ˃xNgƂ̓
		int speculer[] = new int[4];
		float sw = poly.Graphic.innerProduct(n, vView);
		if(sw > 0)
		{
			sw = (float)Math.pow(sw, 4);	//			
			speculer[0] = (int)(sw * vSpeculerColor[0] * 255 * 0xffff);
			speculer[1] = (int)(sw * vSpeculerColor[1] * 255 * 0xffff);
			speculer[2] = (int)(sw * vSpeculerColor[2] * 255 * 0xffff);
		}else{
			speculer[0] = 0;
			speculer[1] = 0;
			speculer[1] = 0;
		}
		speculer[3] = 1;
		return(speculer);
	}
	/**
	 * s(R)xNgs𐶐
	 * make normal light matrix
	 *     | l0x l0y l0z 0 |
	 * M = | l1x l1y l1z 0 |
	 *     | l2x l1y l2z 0 |
	 *     |   0   0   0 1 |
	 * @param	l0	light direction
	 * @param	l1	light direction
	 * @param	l2	light direction
	 */
	static final public void normalLightMatrix(float m[], float l0[], float l1[], float l2[])
	{
		float t[] = new float[4];
		float v1[] = new float[4];
		float v2[] = new float[4];

		unitVector(t);
		unitVector(v1);
		unitVector(v2);
		scaleVector(t, l0, -1);
		normalizeVector(m, t);
		scaleVector(t, l1, -1);
		normalizeVector(v1, t);
		m[4*1+0] = v1[0];
		m[4*1+1] = v1[1];
		m[4*1+2] = v1[2];
		m[4*1+3] = v1[3];
		scaleVector(t, l2, -1);
		normalizeVector(v2, t);
		m[4*2+0] = v2[0];
		m[4*2+1] = v2[1];
		m[4*2+2] = v2[2];
		m[4*2+3] = v2[3];

		m[4*3+0] = m[4*3+1] = m[4*3+2] = 0.0f;
		m[4*3+3] = 1.0f;
	}
	/**
	 * s(R)̃J[s𐶐
	 * make normal light matrix
	 * 	    | c0r c1r c2r ar |
	 * 	M = | c0g c1g c2g ag |
	 * 	    | c0b c1b c2b ab |
	 * 	    |   0   0   0  0 |
	 * @param 	c0	light color
	 * @param 	c1	light color
	 * @param 	c2	light color
	 * @param	a	ambient color
	 */
	static final public void lightColorMatrix(float m[], float c0[], float c1[], float c2[], float a[])
	{
		copyVector(m, c0);
		copyVectorToMatrix1(m, c1);
		copyVectorToMatrix2(m, c2);
		copyVectorToMatrix3(m, a);
		transposeMatrix(m, m);
	}
	/**
	 * e_̃CeBO̐FvZ
	 * vect = local_light * v0;   (inner product)
	 * 0.0 < vect < 1.0;          (clamp)
	 * c0 = local_color * vect;   (inner product)
	 * @param	local_light	light direction(matrix)
	 * @param	light_color	light color(matrix)
	 * @param	v0	vertex normal vector
	 * @param	c0	vertex color
	 */
	static final public void normalColorVector(float c0[], float local_light[], float light_color[], float v0[], float c1[])
	{
		float vect[] = new float[4];
		
		unitVector(vect);
		applyMatrix(vect, local_light, v0);
		clampVector(vect, vect, 0.0f, 1.0f);
		applyMatrix(vect, light_color, vect);
		mulVector(vect, c1, vect);
		clampVector(vect, vect, 0.0f, 255.0f);
		copyVector(c0, vect);
	}
	/**
	 * _WnXN[Wnւ̕ϊs
	 * @param	scrz	distance to screen
	 * @param	ax		aspect ratio
	 * @param	ay		aspect ratio
	 * @param	cx		center
	 * @param	cy		center
	 * @param	zmin	Z-buffer range
	 * @param	zmax	Z-buffer range
	 * @param	nearz	near edge
	 * @param	farz	far edge
	 */
/*
	static public void viewScreenMatrix(
		float m[], 
		float scrz, 
		float ax, float ay, 
		float cx, float cy, 
		float zmin, float zmax, 
		float znear, float zfar
	){
		float az, cz;
		float mt[] = new float[4*4];

		cz = (-zmax * nearz + zmin * farz) / (-nearz + farz);
		az  = farz * nearz * (-zmin + zmax) / (-nearz + farz);

		//     | scrz    0  0 0 |
		// m = |    0 scrz  0 0 |
		//     |    0    0  0 1 |
		//     |    0    0  1 0 |
		unitMatrix(m);
		m[4*0+0] = scrz;
		m[4*1+1] = scrz;
		m[4*2+2] = 0.0f;
		m[4*3+3] = 0.0f;
		m[4*3+2] = 1.0f;
		m[4*2+3] = 1.0f;

		//     | ax  0  0 cx |
		// m = |  0 ay  0 cy |
		//     |  0  0 az cz |
		//     |  0  0  0  1 |
		unitMatrix(mt);
		mt[4*0+0] = ax;
		mt[4*1+1] = ay;
		mt[4*2+2] = az;
		mt[4*0+3] = cx;
		mt[4*1+3] = cy;
		mt[4*2+3] = cz;
		mulMatrix(m, mt, m);
	}
*/

	/**
	 * RotTransPers	ϊ
	 * ^ꂽ_XN[WɓϊB
	 * @param	v0	o:xNg(XN[W)
	 * @param	m0	:}gbNX
	 * @param	v1	:xNg
	 * @return	float ϊ̃xNg̑Svf(Wl)̋t(1/W)ԂDeNX`W STQQlɗp邽߁D
	 */
	static final public void rotTransPers(float v0[], float v1[])
	{
		applyMatrix(v0, mMaster, v1);
		float _z = 1.0f / v0[2];
		v0[0] = v0[0] * _z;
		v0[1] = v0[1] * _z;
	}
	/**
	 * RotTransPers	ϊ
	 * ^ꂽ_XN[WɓϊB
	 * @param	v0	o:xNg(XN[W)
	 * @param	m0	:}gbNX
	 * @param	v1	:xNg
	 * @return	float ϊ̃xNg̑Svf(Wl)̋t(1/W)ԂDeNX`W STQQlɗp邽߁D
	 */
	static final public void rotTransPers(float v0[], float m0[], float v1[])
	{
		applyMatrix(v0, m0, v1);
		float _z = 1.0f / v0[2];
		v0[0] = v0[0] * _z * viewPortWidth + viewPortCenterX;
		v0[1] = v0[1] * _z * viewPortHeight + viewPortCenterY;
	}
	/**
	 * TransposeMatrix	}gbNX̓]us߂
	 * }gbNXm1̓]usm0ɗ^
	 * @param	m1	:}gbNX
	 * @param	m0	o:}gbNX
	 */
	static final public void transposeMatrix(float m0[], float m1[])
	{
		float t[] = new float[4*4];
/*
		for(int i = 0; i < 4; i ++)
		{
			for(int j = 0; j < 4; j ++)
			{
				t[4*i+j] = m1[4*j+i];
			}
		}
*/
		t[0*4+0]=m1[0*4+0];t[0*4+1]=m1[1*4+0];t[0*4+2]=m1[2*4+0];t[0*4+3]=0;
		t[1*4+0]=m1[0*4+1];t[1*4+1]=m1[1*4+1];t[1*4+2]=m1[2*4+1];t[1*4+3]=0;
		t[2*4+0]=m1[0*4+2];t[2*4+1]=m1[1*4+2];t[2*4+2]=m1[2*4+2];t[2*4+3]=0;
		t[3*4+0]=        0;t[3*4+1]=        0;t[3*4+2]=        0;t[3*4+3]=1.0f;		
		copyMatrix(m0, t);
	}
	/**
	 * InversMatrix	ts (4x4) ߂Bis͐Ɖ肷j
	 * }gbNXm1̋ts߂āA}gbNXm0ɗ^
	 * @param	m1	:}gbNX(] & sړ)
	 * @param	m0	o:}gbNX
	 */
	static final public void inversMatrix(float m0[], float m1[])
	{
		float m[] = new float[4*4];
		
		for(int i=0; i<4; i++)
		{
			for(int j=0; j<4; j++)
			{
				m[4*i+j] = m1[4*j+i];
			}
		}
		m[4*0+3] = -(m1[4*0+3]*m[4*0+0] + m1[4*1+3]*m[4*0+1] + m1[4*2+3]*m[4*0+2]);
		m[4*1+3] = -(m1[4*0+3]*m[4*1+0] + m1[4*1+3]*m[4*1+1] + m1[4*2+3]*m[4*1+2]);
		m[4*2+3] = -(m1[4*0+3]*m[4*2+0] + m1[4*1+3]*m[4*2+1] + m1[4*2+3]*m[4*2+2]);
		m[4*3+0] = m[4*3+1] = m[4*3+2] = 0.0f;
		m[4*3+3] = 1.0f;
		copyMatrix(m0, m);
	}
	/**
	 * output vector contents
	 * @param	s	subject
	 * @param	v	vector
	 */
	static final public void dumpVector(String s, float v[])
	{
		System.out.println(s);
		System.out.println("("+v[0]+","+v[1]+","+v[2]+","+v[3]+")");
	}
	/**
	 * output matrix contents
	 * @param	s	subject
	 * @param	m	matrix
	 */
	static final public void dumpMatrix(String s, float m[])
	{
		System.out.println(s);
		System.out.println("["+m[4*0+0]+","+m[4*0+1]+","+m[4*0+2]+","+m[4*0+3]+"]");
		System.out.println("["+m[4*1+0]+","+m[4*1+1]+","+m[4*1+2]+","+m[4*1+3]+"]");
		System.out.println("["+m[4*2+0]+","+m[4*2+1]+","+m[4*2+2]+","+m[4*2+3]+"]");
		System.out.println("["+m[4*3+0]+","+m[4*3+1]+","+m[4*3+2]+","+m[4*3+3]+"]");
	}
}

/**
 * eNX`[NX
 */
class TextureEnvironment
{
	int width;
	int height;
	int maskWidth;
	int maskHeight;
	int shiftCount;
	int pixel[];
	
	TextureEnvironment(Image texture) throws InterruptedException
	{
		PixelGrabber pg;
		
		width = texture.getWidth(null);
		height = texture.getHeight(null);
		maskWidth = width - 1;
		maskHeight = height - 1;

		shiftCount = 0;
		for(int i = 0; i < 32; i ++)
		{
			if(((maskWidth >> i) & 1) > 0)
			{
				shiftCount++;
			}
		}
		
		pixel = new int[width * height];
		pg = new PixelGrabber(texture, 0, 0, width, height, pixel, 0, width);
		pg.grabPixels();
	}
	public int getWidth()
	{
		return width;
	}
	public int getHeight()
	{
		return height;
	}
	public int getMaskWidth()
	{
		return maskWidth;
	}
	public int getMaskHeight()
	{
		return maskHeight;
	}
	public int getShiftCount()
	{
		return shiftCount;
	}
	public int getPixel(int index)
	{
		return pixel[index];
	}
}

/**
 * ƖEϊς݂̒_Ǘ
 * @author  Shun Moriya
 * @version 1.0
 */
class Point
{
	int x;		// _W
	int y;
	int z;
	int r;		// _F
	int g;
	int b;
	int sr;	// XyLF
	int sg;
	int sb;
	int u;		// eNX`W
	int v;
}
