package poly;
import java.util.Vector;

/**
 * Model class
 *
 * @author Shun Moriya <shun126@users.sourceforge.jp>
 */
public class Model
{
	Vector vertexs;
	Vector normals;
	Vector primitives;
	Vector materials;

	public Model()
	{
		materials = new Vector();
		normals = new Vector();
		primitives = new Vector();
		vertexs = new Vector();
	}
	public void appendTexture(String textureFileName)
	{
		materials.addElement(textureFileName);
	}
	public void appendVertex(float x, float y, float z)
	{
		float vertex[] = new float[4];
		poly.Graphic.setVector(vertex, x, y, z);
		vertexs.addElement(vertex);
	}
	public void appendNormal(float x, float y, float z)
	{
		float normal[] = new float[4];
		poly.Graphic.setVector(normal, x, y, z);
		normals.addElement(normal);
	}
	public void appendPrimitive(Primitive primitive)
	{
		primitives.addElement(primitive);
	}
	public void translate(float matrix[], int id)
	{
		float color[] = new float[4];
		poly.Graphic.setMatrix(matrix);
		for(int i = 0; i < primitives.size(); i++)
		{
			Primitive primitive = (Primitive)primitives.elementAt(i);

			poly.Graphic.begin();
			poly.Graphic.setTexture(primitive.material);

			poly.Graphic.setVector(color, primitive.r0, primitive.g0, primitive.b0);
			poly.Graphic.setColor(0, color);
			if(primitive.np0 >= 0)
				poly.Graphic.setNormal(0, (float[])normals.elementAt(primitive.np0));
			if(primitive.vp0 >= 0)
				poly.Graphic.setVertex(0, (float[])vertexs.elementAt(primitive.vp0));
			poly.Graphic.setTexCoord(0, primitive.u0, primitive.v0);

			poly.Graphic.setVector(color, primitive.r1, primitive.g1, primitive.b1);
			poly.Graphic.setColor(1, color);
			if(primitive.np1 >= 0)
				poly.Graphic.setNormal(1, (float[])normals.elementAt(primitive.np1));
			if(primitive.vp1 >= 0)
				poly.Graphic.setVertex(1, (float[])vertexs.elementAt(primitive.vp1));
			poly.Graphic.setTexCoord(1, primitive.u1, primitive.v1);
			
			poly.Graphic.setVector(color, primitive.r2, primitive.g2, primitive.b2);
			poly.Graphic.setColor(2, color);
			if(primitive.np2 >= 0)
				poly.Graphic.setNormal(2, (float[])normals.elementAt(primitive.np2));
			if(primitive.vp2 >= 0)
				poly.Graphic.setVertex(2, (float[])vertexs.elementAt(primitive.vp2));
			poly.Graphic.setTexCoord(2, primitive.u2, primitive.v2);

			poly.Graphic.end();

			if(primitive.quadrangle == true)
			{
//				poly.Graphic.swap();
				poly.Graphic.setVector(color, primitive.r3, primitive.g3, primitive.b3);
				poly.Graphic.setColor(1, color);
				if(primitive.np3 >= 0)
					poly.Graphic.setNormal(1, (float[])normals.elementAt(primitive.np3));
				if(primitive.vp3 >= 0)
					poly.Graphic.setVertex(1, (float[])vertexs.elementAt(primitive.vp3));
				poly.Graphic.setTexCoord(1, primitive.u3, primitive.v3);
				poly.Graphic.end();
			}
		}
	}
}
