package poly;
import java.util.Vector;

/**
 * Scene class
 * 
 * @author Shun Moriya <shun126@users.sourceforge.jp>
 */
public class Scene
{
	public Vector bones;
	public Vector materials;
	
	public Scene()
	{
		bones = new Vector();
		materials = new Vector();
//		animation = new Animation(ean);
	}
	public void appendBone(Bone bone)
	{
		bones.addElement(bone);
	}
	public void appendMaterial(Material material)
	{
		materials.addElement(material);
	}
	public void translate()
	{
		Bone rootBone = (Bone)bones.elementAt(0);
		poly.Graphic.unitMatrix(rootBone.matrix);
		poly.Graphic.rotMatrixYXZ(rootBone.matrix, rootBone.matrix, rootBone.rotation);
		poly.Graphic.setTransMatrix(rootBone.matrix, rootBone.translation);
		poly.Graphic.setTransform(poly.Graphic.TRANSFORM_WORLD, rootBone.matrix);
		poly.Graphic.beginRender();
		poly.Graphic.copyMatrix(rootBone.matrix, poly.Graphic.mMaster);
		if(rootBone.model != null)
		{
			rootBone.model.translate(rootBone.matrix, 0);
		}
		
		for(int i = 1; i < bones.size(); i ++)
		{
			Bone bone = (Bone)bones.elementAt(i);
			poly.Graphic.unitMatrix(bone.matrix);
			poly.Graphic.rotMatrixYXZ(bone.matrix, bone.matrix, bone.rotation);
			poly.Graphic.setTransMatrix(bone.matrix, bone.translation);
			if(bone.parentBone != null)
			{
				poly.Graphic.mulMatrix(bone.matrix, bone.matrix, bone.parentBone.matrix);
			}
			if(bone.model != null)
			{
				bone.model.translate(bone.matrix, 0);
			}
		}
	}
}
