package poly.plugins;

import java.io.*;
import java.util.*;

public class TokenReader
{
	BufferedReader in = null;
	StringTokenizer st = null;
	String line;
	boolean isInit;

	public TokenReader(BufferedReader bufferedReader) throws FileNotFoundException,IOException
	{
		in = bufferedReader;
		isInit = refreshTokenizer();
	}

	private boolean refreshTokenizer() throws IOException
	{
		while((line = in.readLine()) != null)
		{
			// ̒0̏ꍇ͓ǂݒ
			if(line.length() == 0)
				continue;
			// 擪̏ꍇ̓Rgs
			if(line.charAt(0) == '#')
				continue;

			st = new StringTokenizer(line, ",; \t()", false);
			return(true);
		}
		return(false);
	}

	public String next() throws IOException
	{
		if(isInit == true)
		{
			if(st.hasMoreTokens())
			{
				String token = st.nextToken();
				return(token);
			}else{
				if((isInit = refreshTokenizer()) == false)
					return(null);
				if(st.hasMoreTokens())
					return(st.nextToken());
			}
		}
		return(null);
	}

	public boolean empty()
	{
		return !st.hasMoreTokens();
	}
	public float getFloat() throws IOException
	{
		return Float.valueOf(next()).floatValue();
	}

	public int getInt() throws IOException
	{
		return Integer.parseInt(next());
	}

	public String getString() throws IOException
	{
		return next();
	}

	public String getString2() throws IOException
	{
		return next().replace('\"', ' ').trim();
	}

	public String getLine() throws IOException
	{
		nextLine();
		return in.readLine();
	}
	
	public void nextLine()
	{
		while(st.hasMoreTokens())
			st.nextToken();
	}

	public void close() throws IOException
	{
		in.close();
	}
}
